# US ANSI Shifted Symbols

These keycodes correspond to characters that are "shifted" on a standard US ANSI keyboards. They do not have dedicated keycodes but are instead typed by holding down shift and then sending a keycode.

It's important to remember that all of these keycodes send a left shift - this may cause unintended actions if unaccounted for. The short code is preferred in most situations.

## US ANSI Shifted Keycodes

|Key                     |Aliases           |Description        |
|------------------------|------------------|-------------------|
|`KC_TILDE`              |`KC_TILD`         |`~`                |
|`KC_EXCLAIM`            |`KC_EXLM`         |`!`                |
|`KC_AT`                 |                  |`@`                |
|`KC_HASH`               |                  |`#`                |
|`KC_DOLLAR`             |`KC_DLR`          |`$`                |
|`KC_PERCENT`            |`KC_PERC`         |`%`                |
|`KC_CIRCUMFLEX`         |`KC_CIRC`         |`^`                |
|`KC_AMPERSAND`          |`KC_AMPR`         |`&`                |
|`KC_ASTERISK`           |`KC_ASTR`         |`*`                |
|`KC_LEFT_PAREN`         |`KC_LPRN`         |`(`                |
|`KC_RIGHT_PAREN`        |`KC_RPRN`         |`)`                |
|`KC_UNDERSCORE`         |`KC_UNDS`         |`_`                |
|`KC_PLUS`               |                  |`+`                |
|`KC_LEFT_CURLY_BRACE`   |`KC_LCBR`         |`{`                |
|`KC_RIGHT_CURLY_BRACE`  |`KC_RCBR`         |`}`                |
|`KC_PIPE`               |                  |<code>&#124;</code>|
|`KC_COLON`              |`KC_COLN`         |`:`                |
|`KC_DOUBLE_QUOTE`       |`KC_DQT`/`KC_DQUO`|`"`                |
|`KC_LEFT_ANGLE_BRACKET` |`KC_LT`/`KC_LABK` |`<`                |
|`KC_RIGHT_ANGLE_BRACKET`|`KC_GT`/`KC_RABK` |`>`                |
|`KC_QUESTION`           |`KC_QUES`         |`?`                |
